// Auto-generated. Do not edit!

// (in-package radar_omnipresense.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let fft = require('./fft.js');
let raw = require('./raw.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class radar_data {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.speed = null;
      this.direction = null;
      this.time = null;
      this.sensorid = null;
      this.objnum = null;
      this.metadata = null;
      this.fft_data = null;
      this.raw_data = null;
    }
    else {
      if (initObj.hasOwnProperty('speed')) {
        this.speed = initObj.speed
      }
      else {
        this.speed = 0.0;
      }
      if (initObj.hasOwnProperty('direction')) {
        this.direction = initObj.direction
      }
      else {
        this.direction = '';
      }
      if (initObj.hasOwnProperty('time')) {
        this.time = initObj.time
      }
      else {
        this.time = 0.0;
      }
      if (initObj.hasOwnProperty('sensorid')) {
        this.sensorid = initObj.sensorid
      }
      else {
        this.sensorid = '';
      }
      if (initObj.hasOwnProperty('objnum')) {
        this.objnum = initObj.objnum
      }
      else {
        this.objnum = 0.0;
      }
      if (initObj.hasOwnProperty('metadata')) {
        this.metadata = initObj.metadata
      }
      else {
        this.metadata = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('fft_data')) {
        this.fft_data = initObj.fft_data
      }
      else {
        this.fft_data = new fft();
      }
      if (initObj.hasOwnProperty('raw_data')) {
        this.raw_data = initObj.raw_data
      }
      else {
        this.raw_data = new raw();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type radar_data
    // Serialize message field [speed]
    bufferOffset = _serializer.float32(obj.speed, buffer, bufferOffset);
    // Serialize message field [direction]
    bufferOffset = _serializer.string(obj.direction, buffer, bufferOffset);
    // Serialize message field [time]
    bufferOffset = _serializer.float32(obj.time, buffer, bufferOffset);
    // Serialize message field [sensorid]
    bufferOffset = _serializer.string(obj.sensorid, buffer, bufferOffset);
    // Serialize message field [objnum]
    bufferOffset = _serializer.float32(obj.objnum, buffer, bufferOffset);
    // Serialize message field [metadata]
    bufferOffset = std_msgs.msg.Header.serialize(obj.metadata, buffer, bufferOffset);
    // Serialize message field [fft_data]
    bufferOffset = fft.serialize(obj.fft_data, buffer, bufferOffset);
    // Serialize message field [raw_data]
    bufferOffset = raw.serialize(obj.raw_data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type radar_data
    let len;
    let data = new radar_data(null);
    // Deserialize message field [speed]
    data.speed = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [direction]
    data.direction = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [time]
    data.time = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [sensorid]
    data.sensorid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [objnum]
    data.objnum = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [metadata]
    data.metadata = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [fft_data]
    data.fft_data = fft.deserialize(buffer, bufferOffset);
    // Deserialize message field [raw_data]
    data.raw_data = raw.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.direction.length;
    length += object.sensorid.length;
    length += std_msgs.msg.Header.getMessageSize(object.metadata);
    length += fft.getMessageSize(object.fft_data);
    length += raw.getMessageSize(object.raw_data);
    return length + 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'radar_omnipresense/radar_data';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7d9b638f84084a7549fbb8e58a7f343a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    float32 speed
    string  direction
    float32 time
    string  sensorid
    float32 objnum
    Header  metadata
    fft     fft_data
    raw     raw_data
    
    
    
    
    
    
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: radar_omnipresense/fft
    float32[] real
    float32[] imaginary
    
    ================================================================================
    MSG: radar_omnipresense/raw
    int32[] i
    int32[] q
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new radar_data(null);
    if (msg.speed !== undefined) {
      resolved.speed = msg.speed;
    }
    else {
      resolved.speed = 0.0
    }

    if (msg.direction !== undefined) {
      resolved.direction = msg.direction;
    }
    else {
      resolved.direction = ''
    }

    if (msg.time !== undefined) {
      resolved.time = msg.time;
    }
    else {
      resolved.time = 0.0
    }

    if (msg.sensorid !== undefined) {
      resolved.sensorid = msg.sensorid;
    }
    else {
      resolved.sensorid = ''
    }

    if (msg.objnum !== undefined) {
      resolved.objnum = msg.objnum;
    }
    else {
      resolved.objnum = 0.0
    }

    if (msg.metadata !== undefined) {
      resolved.metadata = std_msgs.msg.Header.Resolve(msg.metadata)
    }
    else {
      resolved.metadata = new std_msgs.msg.Header()
    }

    if (msg.fft_data !== undefined) {
      resolved.fft_data = fft.Resolve(msg.fft_data)
    }
    else {
      resolved.fft_data = new fft()
    }

    if (msg.raw_data !== undefined) {
      resolved.raw_data = raw.Resolve(msg.raw_data)
    }
    else {
      resolved.raw_data = new raw()
    }

    return resolved;
    }
};

module.exports = radar_data;
